/* 
The NIST RCS (Real-time Control Systems) 
 library is public domain software, however it is preferred
 that the following disclaimers be attached.

Software Copywrite/Warranty Disclaimer

   This software was developed at the National Institute of Standards and
Technology by employees of the Federal Government in the course of their
official duties. Pursuant to title 17 Section 105 of the United States
Code this software is not subject to copyright protection and is in the
public domain. NIST Real-Time Control System software is an experimental
system. NIST assumes no responsibility whatsoever for its use by other
parties, and makes no guarantees, expressed or implied, about its
quality, reliability, or any other characteristic. We would appreciate
acknowledgement if the software is used. This software can be
redistributed and/or modified freely provided that any derivative works
bear some notice that they are derived from it, and any modified
versions bear some notice that they have been modified.



*/ 

/*
*       New Java File starts here.
*       This file should be named PmQuaternion.java
*/


// Set Package Name
package rcs.posemath;

// Import all NML, CMS, and RCS classes and interfaces
import rcs.nml.NMLFormatConverter;

/*
*       Class definition for PmQuaternion
*       Automatically generated by RCS Java Diagnostics Tool.
*       on Wed Jan 07 10:53:47 EST 1998
*/
public class PmQuaternion implements Cloneable
{
  public double s = 0;
  public double x = 0;
  public double y = 0;
  public double z = 0;

  public void update(NMLFormatConverter nml_fc)
  {
      nml_fc.beginClass("PmQuaternion",null);
      s = nml_fc.update_with_name("s",s);
      x = nml_fc.update_with_name("x",x);
      y = nml_fc.update_with_name("y",y);
      z = nml_fc.update_with_name("z",z);
      nml_fc.endClass("PmQuaternion",null);
  }

  public PmQuaternion()
  {
  }

  public PmQuaternion(double starts, double startx, double startz, double starty) throws PmException
  {
    s = starts;
    x = startx;
    y = starty;
    z = startz;
    Posemath.pmQuatNorm(this,this);
  }

  public String toString()
  {
    return " { s = "+s+", x ="+x+", y = "+y+", z = "+z+" } ";
  }

  public boolean equals(PmQuaternion pq) throws PmException
  {
    if(null == pq)
      {
        return false;
      }
    return Posemath.pmQuatQuatCompare(this,pq);
  }

  public boolean equals(PmRotationMatrix prm) throws PmException
  {
    if(null == prm)
      {
        return false;
      }
    PmQuaternion pq = new PmQuaternion();
    Posemath.pmMatQuatConvert(prm,pq);
    return Posemath.pmQuatQuatCompare(this,pq);
  }

  public boolean equals(PmRotationVector prv) throws PmException
  {
    if(null == prv)
      {
        return false;
      }
    PmQuaternion pq = new PmQuaternion();
    Posemath.pmRotQuatConvert(prv,pq);
    return Posemath.pmQuatQuatCompare(this,pq);
  }
  
  public Object clone() throws CloneNotSupportedException
  {
      PmQuaternion cloned_object = (PmQuaternion) super.clone();
      return cloned_object;
  }
}
